/*

Copyright (c) 2009, Oliver Martin <oliver@volatilevoid.net>

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

*/

package net.volatilevoid.glowingpear;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Build;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;

public class Glowingpear extends Activity {

	private Lightbulb light;
	private String devnode;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		if (Build.BOARD.equals("GT-I7500")) {
			light = new Lightbulb("galaxy");
			devnode = "/dev/msm_camera0";
		} else {
			fail("Sorry, your device is currently not supported.");
		}

		if (light != null) {
			ImageView iv = (ImageView) findViewById(R.id.imgLightbulb);
			iv.setOnClickListener(new OnClickListener() {
				public void onClick(View v) {
					light.flash(100000);
				}
			});
		}
	}

	public void onResume() {
		super.onResume();
		if (light != null) {
			if (!light.open(devnode)) {
				fail("Sorry, can't open camera device.");
				return;
			}
			light.start();
		}
	}

	public void onPause() {
		super.onPause();
		if (light != null) {
			light.stop();
			light.close();
		}
	}

	private void fail(String txt) {
		AlertDialog msg = new AlertDialog.Builder(this).create();
		msg.setTitle("Oops!");
		msg.setMessage(txt);
		msg.setButton("OK", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int which) {
				System.exit(0);
			} });
		msg.show();
	}
}
